if(!phpal) var phpal={};
if(!phpal.imgsh) phpal.imgsh={};
if(!phpal.imgsh.myPackage) phpal.imgsh.myPackage={};

phpal.imgsh.myPackage={

m_prefs: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch),

//setting options from config file to config window on opening config window
initSetting: function()
{
//getting mode for load or not page after switching off-on images
rldyn = phpal.imgsh.myPackage.m_prefs.getIntPref("imgsh.rldyn");

//geeting last used mode
rldef = phpal.imgsh.myPackage.m_prefs.getIntPref("imgsh.rldef");

//geeting default-startup mode
rldstup = phpal.imgsh.myPackage.m_prefs.getIntPref("imgsh.rldstup");

//setting mode for load or not page after switching off-on images to config window
switch (rldyn) {
   case 0 : 
document.getElementById('rld').checked = false;
document.getElementById('rld2').checked = false;
      break; 
   case 1 : 
document.getElementById('rld').checked = true;
document.getElementById('rld2').checked = false;
      break; 
   case 2 : 
document.getElementById('rld').checked = false;
document.getElementById('rld2').checked = true;
      break; 
   case 3 : 
document.getElementById('rld').checked = true;
document.getElementById('rld2').checked = true;
      break;
   default : 
document.getElementById('rld').checked = false;
document.getElementById('rld2').checked = false;
} 

//setting last used image show mode to config window
document.getElementById('rld3').value=rldef;

//setting default-startup mode to config window
document.getElementById('rld4').value=rldstup;
}, 
//end initSetting

//setting options from config window to config file when clicked OK in config window
imgsh_switchyn: function() {

//calculating option for reload or not page on show-hide images
    if (document.getElementById('rld').checked) { rldyns1=1; } else { rldyns1=0; };
    if (document.getElementById('rld2').checked) { rldyns2=2; } else { rldyns2=0; };
//saving calculated option
    phpal.imgsh.myPackage.m_prefs.setIntPref("imgsh.rldyn", rldyns1+rldyns2);

//getting and saving option for selected and last used image show mode
    rldeff=document.getElementById('rld3').value;
    phpal.imgsh.myPackage.m_prefs.setIntPref("imgsh.rldef", rldeff);

//getting and saving option for default-startup mode
    rldstupp=document.getElementById('rld4').value;
    phpal.imgsh.myPackage.m_prefs.setIntPref("imgsh.rldstup", rldstupp);

},
//end imgsh_switchyn

//change working-current image display mode by clicking toolbar button or by hotkey only if there are no FindToolbar
imgsh_switchimg: function() {
    nCurImgType = phpal.imgsh.myPackage.m_prefs.getIntPref("permissions.default.image");
    if (nCurImgType == 2 && document.getElementById("FindToolbar").hidden == true) {
        phpal.imgsh.myPackage.imgsh_setShow("net");
    } else if (nCurImgType == 3 || nCurImgType == 1 && document.getElementById("FindToolbar").hidden == true) {
        phpal.imgsh.myPackage.imgsh_setHide("net");
    }
},
//end imgsh_switchimg

//funtion to turn images on
imgsh_setShow: function(danet) {
	if(danet == "da") {
	    var nCurDefType = phpal.imgsh.myPackage.m_prefs.getIntPref("imgsh.rldstup");
	} else if (danet == "net") {
	    var nCurDefType = phpal.imgsh.myPackage.m_prefs.getIntPref("imgsh.rldef");
	}
    phpal.imgsh.myPackage.m_prefs.setBoolPref("browser.display.show_image_placeholders", true);
    phpal.imgsh.myPackage.m_prefs.setIntPref("permissions.default.image", nCurDefType);

    var sPrefix;
    if (document.getElementById("navigator-toolbox").getAttribute("iconsize")=='small') {
        sPrefix = 'small';
    } else {
        sPrefix = 'big';
    }

    var nCurYNType = phpal.imgsh.myPackage.m_prefs.getIntPref("imgsh.rldyn");
    if ((nCurYNType == 1 || nCurYNType == 3) && danet != "da") { window._content.location.reload(); }

    var turnoff = document.getElementById('imgsh-strings').getString("TurnOffTooltip");
    m_button = document.getElementById("imgsh-button");
    if (m_button) {
    m_button.setAttribute('image', 'chrome://imgsh/skin/'+sPrefix+'button.png');
    m_button.setAttribute('tooltiptext', turnoff);
    }
},
//end imgsh_setShow

//funtion to hide images
imgsh_setHide: function (danet) {
    phpal.imgsh.myPackage.m_prefs.setIntPref("permissions.default.image", 2);
    phpal.imgsh.myPackage.m_prefs.setBoolPref("browser.display.show_image_placeholders", false);
    if (document.getElementById("navigator-toolbox").getAttribute("iconsize")=='small') {
        sPrefix = 'small';
    } else {
        sPrefix = 'big';
    }

    var nCurYNType = phpal.imgsh.myPackage.m_prefs.getIntPref("imgsh.rldyn");
    if ((nCurYNType == 2 || nCurYNType == 3) && danet != "da") { window._content.location.reload(); }

    var turnon = document.getElementById('imgsh-strings').getString("TurnOnTooltip");
    m_button = document.getElementById("imgsh-button");
    if (m_button) {
    m_button.setAttribute('image', 'chrome://imgsh/skin/'+sPrefix+'button_gr.png');
    m_button.setAttribute('tooltiptext', turnon);
    }
}
//end imgsh_setHide 

}
//end of imgsh package

//imgsh startup,first run,setting all default values in config file
window.addEventListener("load", function()
{   
      // localizing description :o)
      var imgshLocalizationPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.{92A24891-BA14-4e89-9FFD-07FFBE4334EE}.");
      var str = Components.classes[ "@mozilla.org/supports-string;1" ].createInstance( Components.interfaces.nsISupportsString );
      str.data = document.getElementById("imgsh-strings").getString("ImgshDescription");
      imgshLocalizationPrefs.setComplexValue( "description", Components.interfaces.nsISupportsString, str );

//setting default values to config file
    var nCurImgType = phpal.imgsh.myPackage.m_prefs.getIntPref("permissions.default.image");
    if (!phpal.imgsh.myPackage.m_prefs.prefHasUserValue("imgsh.rldyn")) { phpal.imgsh.myPackage.m_prefs.setIntPref("imgsh.rldyn", 0); } 
    if (!phpal.imgsh.myPackage.m_prefs.prefHasUserValue("imgsh.rldef")) { phpal.imgsh.myPackage.m_prefs.setIntPref("imgsh.rldef", nCurImgType); } 
    if (!phpal.imgsh.myPackage.m_prefs.prefHasUserValue("imgsh.rldstup")) { phpal.imgsh.myPackage.m_prefs.setIntPref("imgsh.rldstup", nCurImgType); }

//setting current image show mode
	//geeting default-startup mode
	rldstup = phpal.imgsh.myPackage.m_prefs.getIntPref("imgsh.rldstup");
	if(rldstup) { phpal.imgsh.myPackage.m_prefs.setIntPref("permissions.default.image", rldstup); }

//appling mode
    var nCurImgType = phpal.imgsh.myPackage.m_prefs.getIntPref("permissions.default.image");
    if (nCurImgType == 3 || nCurImgType == 1) {
        phpal.imgsh.myPackage.imgsh_setShow("da");
    } else if (nCurImgType == 2) {
        phpal.imgsh.myPackage.imgsh_setHide("da");
    }
}, false);